CodeForces 535C Tavas and Karafs

来源:互联网 发布:网络大电影分成模式 编辑:程序博客网 时间:2024/06/07 22:54

Tavas and Karafs
Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u

Description

Karafs is some kind of vegetable in shape of an 1 × h rectangle. Tavaspolis people love Karafs and they use Karafs in almost any kind of food. Tavas, himself, is crazy about Karafs.

Each Karafs has a positive integer height. Tavas has an infinite 1-based sequence of Karafses. The height of the i-th Karafs is si = A + (i - 1) × B.

For a given m, let's define an m-bite operation as decreasing the height of at most m distinct not eaten Karafses by 1. Karafs is considered as eaten when its height becomes zero.

Now SaDDas asks you n queries. In each query he gives you numbers lt and m and you should find the largest number r such that l ≤ rand sequence sl, sl + 1, ..., sr can be eaten by performing m-bite no more than t times or print -1 if there is no such number r.

Input

The first line of input contains three integers AB and n (1 ≤ A, B ≤ 1061 ≤ n ≤ 105).

Next n lines contain information about queries. i-th line contains integers l, t, m (1 ≤ l, t, m ≤ 106) for i-th query.

Output

For each query, print its answer in a single line.

Sample Input

Input
2 1 41 5 33 3 107 10 26 4 8
Output
4-18-1
Input
1 5 21 5 102 7 4
Output
12

题意
一个以 A 为首项,B 为公差的等差数列,有 n 个询问。每次询问包含 l,t,m,表示从第 l 项开始取连续的 m 个数做 t 次 -1 运算,若第 l 项减为 0 则区间依次向后移。问最长的连续的 0 区间长度是多少。


分析
假设满足条件的最后一项为 r ,可以发现有这样的规律,max(sl,sl+1,sl+2……,sr) <= t && (sl+sr)*(b-a+1)/2 <= t*m 所以针对这两个条件在(left,right)区间二分就可以了,其中left = l,right = (t-A)/B + 1。


AC代码如下

#include<iostream>#include<cstdio>#include<cstring>#define INF 1000000using namespace std;long long int a,b,n,l,t,m;long long int calc(int l){    return a + ( l - 1 ) * b ;}long long int calc2(int a,int b){    return (calc(a) + calc(b))*(b - a + 1) / 2;}long long int query(){    if(calc(l) > t) return -1;    long long int le = l,ri = (t - a) / b + 1,mid;    while(le <= ri)<span style="white-space:pre"></span>//二分查找    {        mid = (le + ri) / 2;        if(calc2(l,mid) <= t*m) le = mid + 1;        else ri = mid - 1;    }    return le - 1;}int main(){    scanf("%d%d%d",&a,&b,&n);    for(int i = 0 ; i < n; i++)    {        scanf("%d%d%d",&l,&t,&m);        long long int ans = query();        printf("%d\n",ans);    }    return 0;}


0 0
原创粉丝点击